using Test
using DistributionModelsPHT
using Distributions

println("... for DistributionModelsPHT:")

@testset "Generalized gamma distribution" begin
    @test params(GGamma()) == (1.0, 1.0, 1.0)
    @test shape(GGamma(4,2,3)) == (2.0, 3.0)
    @test scale(GGamma(4,2,3)) == 4.0
    @test rate(GGamma(4,2,3)) == 0.25
end

@testset "Fitted models" begin
    @test typeof(AreaPoissonPolygon(1)) == AreaPoissonPolygon{Float64}
    @test typeof(AreaPoissonPolygon(2.0)) <: ContinuousUnivariateDistribution
    @test Distributions.component_type(AreaPoissonPolygon(1)) == GGamma
    @test typeof(AreaCroftonPolygon(1)) == AreaCroftonPolygon{Float64}
    @test typeof(AreaCroftonPolygon(2.0)) <: ContinuousUnivariateDistribution
    @test Distributions.component_type(AreaCroftonPolygon(1)) == GGamma
    @test typeof(VolumePoissonPolyhedron(1)) == VolumePoissonPolyhedron{Float64}
    @test typeof(VolumePoissonPolyhedron(2.0)) <: ContinuousUnivariateDistribution
    @test Distributions.component_type(VolumePoissonPolyhedron(1)) == GGamma
    @test typeof(VolumeCroftonPolyhedron(1)) == VolumeCroftonPolyhedron{Float64}
    @test typeof(VolumeCroftonPolyhedron(2.0)) <: ContinuousUnivariateDistribution
    @test Distributions.component_type(VolumeCroftonPolyhedron(1)) == GGamma
    @test typeof(SurfacePoissonPolyhedron(1)) == SurfacePoissonPolyhedron{Float64}
    @test typeof(SurfacePoissonPolyhedron(2.0)) <: ContinuousUnivariateDistribution
    @test Distributions.component_type(SurfacePoissonPolyhedron(1)) == GGamma
    @test typeof(SurfaceCroftonPolyhedron(1)) == SurfaceCroftonPolyhedron{Float64}
    @test typeof(SurfaceCroftonPolyhedron(2.0)) <: ContinuousUnivariateDistribution
    @test Distributions.component_type(SurfaceCroftonPolyhedron(1)) == GGamma
end